#include "team.h"
#include "dude.h"

Team::Team(const glm::vec3 &spawnColor, const glm::vec3 &dudeColor, BehaviorFunction _behavior):
    m_spawnColor(spawnColor),
    m_dudeColor(dudeColor),
    m_spawnCooldown(1),
    m_foodQuantity(NB_STARTING_FOOD),
    m_behavior(_behavior)
{
}

bool Team::updateSpawn()
{
    if(m_foodQuantity > 0)
    {
        --m_spawnCooldown;
        if(!m_spawnCooldown)
        {
            m_spawnCooldown = SPAWN_COOLDOWN;
            --m_foodQuantity;
            return true;
        }
    }
    return false;
}
void Team::destroySpawn(){
    m_spawnCooldown = 0;
    m_foodQuantity = 0;
}


Action* Team::update(Dude *dude)
{
    Action* action;
    m_behavior(action, dude->getMemory(),(Info*) dude);
    return action;
}
